
class Cas:
    def __init__(self, hodiny, minuty):
        self.hodiny = hodiny
        self.minuty = minuty

    def __str__(self):
        return f'{self.hodiny}:{self.minuty}'           # ak sú minúty v tvare jednociferného čísla, tak vo výpise požadujeme 0-lu na mieste desiatok 

    def vypis(self):
        print('cas je', self)

        

c = Cas(7, 5)
c.vypis()

print('------------------') 















# volanie metódy z inej metódy

class Time:
    def __init__(self, hodiny, minuty):
        self.hours = hodiny
        self.minutes = minuty

    def __str__(self):
        return f'{self.hours}:{self.minutes:02}'       # ak sú minúty v tvare jednociferného čísla, tak vo výpise bude 0-la na mieste desiatok 

    def write(self):
        print('cas je', self)

    def copy(self):
        return Time(self.hours, self.minutes)

    def assign(self, hodiny, minuty):
        self.hours += hodiny + (self.minutes + minuty) // 60
        self.minutes = (self.minutes + minuty) % 60

    def copy_and_assign(self, hodiny, minuty):
        new = self.copy()
        new.assign(hodiny, minuty)
        return new

    
t1 = Time(8, 45)
t1.write()

t1.assign(2,20)
t1.write()

print('------------------')

t2=t1.copy_and_assign(2,20)
t1.write()
t2.write()

print('------------------')

t1.assign(1,1)
t1.write()
t2.write()

print('------------------')

t2.assign(2,2)
t1.write()
t2.write()

print('------------------')












# trieda len s pravými funkciami vďaka čomu sa bude správať ako immutable 


class Timeone:
    def __init__(self, hodiny=0, minuty=0, sekundy=0):
        self.hours = hodiny
        self.minutes = minuty
        self.seconds = sekundy

    def __str__(self):
        return f'{self.hours}:{self.minutes:02}:{self.seconds:02}'

    def sum(self, iny):
        return Timeone(self.hours+iny.hours, self.minutes+iny.minutes, self.seconds+iny.seconds)

    def greater(self, iny):
        return (self.hours > iny.hours or
                self.hours == iny.hours and self.minutes > iny.minutes or
                self.hours == iny.hours and self.minutes == iny.minutes and self.seconds > iny.seconds)

cas1 = Timeone(9, 28, 20)
cas2 = Timeone(10, 48, 55)
print('cas1 =', cas1)
print('cas2 =', cas2)
print('sucet =', cas1.sum(cas2))
print('cas1 > cas2 je ', cas1.greater(cas2))
print('cas2 > cas1 je ', cas2.greater(cas1))

print('------------------')











class Timetwo:
    def __init__(self, hodiny=0, minuty=0, sekundy=0):
        cas = abs(3600*hodiny + 60*minuty + sekundy)
        self.hours = cas // 3600
        self.minutes = cas // 60 % 60
        self.seconds = cas % 60

    def __str__(self):
        return f'{self.hours}:{self.minutes:02}:{self.seconds:02}'

    def sum(self, iny):
        return Timetwo(self.hours+iny.hours, self.minutes+iny.minutes, self.seconds+iny.seconds)

    def number_seconds(self):
        return 3600 * self.hours + 60 * self.minutes + self.seconds

    def greater(self, iny):
        return self.number_seconds() > iny.number_seconds()


cas3 = Timetwo(9, 28, 20)
cas4 = Timetwo(10, 48, 55)
print('cas3 =', cas3)
print('cas4 =', cas4)
print('sucet =', cas3.sum(cas4))
print('cas3 > cas4 je ', cas3.greater(cas4))
print('cas4 > cas3 je ', cas4.greater(cas3))







