# využitie niektorých vlastností vytvorených tried s možnosťou doplnenia či úpravy

import tkinter
import kompozicia #modul s triedou Znacka 
canvas = tkinter.Canvas(width=800, height=400)
canvas.pack()


class ParovaZnacka(kompozicia.Znacka):
   def __init__(self, x, y, rychlost, koniec, canvas):
      kompozicia.Znacka.__init__(self, x, y, rychlost, canvas)
      self.koniec = koniec

   def kresli(self):
      kompozicia.Znacka.kresli(self)
      if self.koniec:
         self.ciara = self.cnv.create_line(self.x+42, self.y-42, self.x-42, self.y+42, width=10)
         self.cnv.itemconfig(self.oval, outline='black', width=1)
         self.cnv.itemconfig(self.text, fill='grey')

   def zmaz(self):
      self.cnv.delete(self.oval)
      self.cnv.delete(self.text)
      self.cnv.delete(self.ciara)

   def prepni(self):
      self.zmaz()
      self.koniec = not self.koniec
      self.kresli()


      
def lavy_klik(sur):
   if z1.je_na_znacke(sur.x, sur.y):
     z1.zmen_rychlost(10)
    
def pravy_klik(sur):
   if z1.je_na_znacke(sur.x, sur.y):
      z1.zmen_rychlost(-10)
      
def stredny_klik(sur):
   if z1.je_na_znacke(sur.x, sur.y):
      z1.prepni()

      
z1 = ParovaZnacka(80, 80, 50, True, canvas)
z1.kresli()
canvas.bind('<Button-1>', lavy_klik)
canvas.bind('<Button-2>', stredny_klik)
canvas.bind('<Button-3>', pravy_klik)


